<?php
define(DIMENSION, 400);  // half the size of the canvas
define(OFFSET, 50);      // axis offset

$iMultiplier = -1;
$iPower = 2;
$cOp = "-";
$iConstant = 3;

$aPoints = array(x => array(), y => array());

// walk the arrays generating the result in the y array
for ($i = 0; $i < (DIMENSION - OFFSET); $i++) {

    // assign x value and initial y value ie same as y = x
    $aPoints["x"][$i] = $i;    
    $aPoints["y"][$i] = $i;
    if ($i != 0) {
       $aPoints["x"][$i * -1] = $i * -1;
       $aPoints["y"][$i * -1] = $i * -1;
    }

    // apply the power to y if there is one
    if ($iPower != -1) {
       $aPoints["y"][$i] = pow($aPoints["y"][$i], $iPower);
        if ($i != 0) $aPoints["y"][$i * -1] = pow($aPoints["y"][$i * -1], $iPower);
    }

    // apply the multiplier to y if there is one
    if ($iMultiplier != -1) {
       $aPoints["y"][$i] = $aPoints["y"][$i] * $iMultiplier;
        if ($i != 0) $aPoints["y"][$i * -1] = $aPoints["y"][$i * -1] * $iMultiplier;
    }

    // apply the constant to y is there is one   
    switch($cOp) {
       case "+" :
             $aPoints["y"][$i] = $aPoints["y"][$i] + $iConstant;
             if ($i != 0) $aPoints["y"][$i * -1] = $aPoints["y"][$i * -1] + $iConstant;
             break;
       case "-" :
             $aPoints["y"][$i] = $aPoints["y"][$i] - $iConstant;
              if ($i != 0) $aPoints["y"][$i * -1] = $aPoints["y"][$i * -1] - $iConstant;
             break;
       case "*" :
             $aPoints["y"][$i] = $aPoints["y"][$i] * $iConstant;
             if ($i != 0) $aPoints["y"][$i * -1] = $aPoints["y"][$i * -1] * $iConstant;
             break;
       case "+" :
             $aPoints["y"][$i] = $aPoints["y"][$i] / $iConstant;
             if ($i != 0) $aPoints["y"][$i * -1] = $aPoints["y"][$i * -1] / $iConstant;
             break;
    }
}

?>

<!DOCTYPE HTML>
   <html>            
       <head>
          <title>Equation Grapher</title>          
       </head>
       <body>
          <table>
             <tr>
               <td>                   
               </td>
               <td>
                   <canvas id="myCanvas" width="<?php echo DIMENSION * 2 ?>" height="<?php echo DIMENSION * 2 ?>" style="border:1px solid #000000;">
                   </canvas>
                   <script>
                      var c = document.getElementById("myCanvas");
                      var ctx = c.getContext("2d");
                      ctx.font = "25px Arial";
                      ctx.fillText("y",<?php echo DIMENSION - 3; ?>, <?php echo OFFSET - 10; ?>);
                      ctx.fillText("x",<?php echo OFFSET - 15; ?>,<?php echo DIMENSION + 5; ?>);
                      ctx.beginPath();
                      ctx.strokeStyle = 'black';
                      ctx.moveTo(<?php echo DIMENSION; ?>,<?php echo OFFSET; ?>);
                      ctx.lineTo(<?php echo DIMENSION; ?>,<?php echo DIMENSION * 2 - OFFSET; ?>);
                      ctx.stroke();
                      ctx.moveTo(<?php echo OFFSET; ?>,<?php echo DIMENSION; ?>);
                      ctx.lineTo(<?php echo DIMENSION * 2 - OFFSET; ?>,<?php echo DIMENSION; ?>);
                      ctx.stroke();
                      ctx.beginPath();
                      ctx.strokeStyle = 'red';
                      <?php
                           // walk the arrays generating the result in the y array
                           for ($i = 0; $i < (DIMENSION - OFFSET - 1); $i++) {
                               $iThisXP = DIMENSION + $aPoints["x"][$i];
                               $iThisYP = DIMENSION - $aPoints["y"][$i];
                               $iThisXN = DIMENSION + $aPoints["x"][$i * -1];
                               $iThisYN = DIMENSION - $aPoints["y"][$i * -1];
                               $iNextXP = DIMENSION + $aPoints["x"][$i + 1];
                               $iNextYP = DIMENSION - $aPoints["y"][$i + 1];
                               $iNextXN = DIMENSION + $aPoints["x"][($i + 1) * -1];
                               $iNextYN = DIMENSION - $aPoints["y"][($i + 1) * -1];
                               if (($iThisXP <= (DIMENSION * 2) - OFFSET) &&
                                   ($iThisXP >= OFFSET) &&
                                   ($iThisYP <= (DIMENSION * 2) - OFFSET) &&
                                   ($iThisYP >= OFFSET) &&
                                   ($iNextXP <= (DIMENSION * 2) - OFFSET) &&
                                   ($iNextXP >= OFFSET) &&
                                   ($iNextYP <= (DIMENSION * 2) - OFFSET) &&
                                   ($iNextYP >= OFFSET)) {
                                      echo "                      ctx.moveTo($iThisXP,$iThisYP);\n";
                                      echo "                      ctx.lineTo($iNextXP,$iNextYP);\n";
                                      echo "                      ctx.stroke();\n";
                                      echo "                      ctx.moveTo($iThisXN,$iThisYN);\n";
                                      echo "                      ctx.lineTo($iNextXN,$iNextYN);\n";
                                      echo "                      ctx.stroke();\n";
                               }
                           }
                      ?>
                  </script>
               </td>
             </tr>
           </table>
       </body>
   </html>
